
import java.beans.Beans;
import java.util.Properties;
import java.util.HashMap;
import java.net.URL;
import javax.naming.directory.DirContext;
import javax.naming.directory.InitialDirContext;

/**
 * Publishes an object.
 *
 */
public
class Publish {

  public
  static
  void
  main(String [] rgstring) {
    if (rgstring.length < 1) {
      System.out.println("Usage: java Publish <URL> [name class]...");
      System.exit(-1);
    }
    try {
      Properties properties = new Properties();
      // Load the properties from the specified URL.
      properties.load(new URL(rgstring[0]).openStream());
      // Use the properties to establish an initial directory context.
      DirContext dircontext = new InitialDirContext(properties);
      // Get the name of the library.
      String stringName = properties.getProperty("library.name");
      // Lookup a library using the specified name.
      Library library = (Library)dircontext.lookup(stringName);
      // Close the context.
      dircontext.close();
      // For each command-line argument, instantiate the specified
      // object, and publish it to the library.
      for (int i = 1; i < rgstring.length; i++) {
        Object object = Beans.instantiate(null, rgstring[i + 1]);
        library.publish(object, rgstring[i], new HashMap());
        i++;
      }
    }
    catch (Exception exception) {
      exception.printStackTrace();
      System.exit(-1);
    }
  }
}
